diff a/src/hotspot/share/compiler/abstractCompiler.hpp b/src/hotspot/share/compiler/abstractCompiler.hpp
--- a/src/hotspot/share/compiler/abstractCompiler.hpp
+++ b/src/hotspot/share/compiler/abstractCompiler.hpp
@@ -33,19 +33,20 @@
 
 // Per-compiler statistics
 class CompilerStatistics {
   friend class VMStructs;
 
+ public:
   class Data {
     friend class VMStructs;
   public:
     elapsedTimer _time;  // time spent compiling
     uint _bytes;         // number of bytecodes compiled, including inlined bytecodes
     uint _count;         // number of compilations
     Data() : _bytes(0), _count(0) {}
     void update(elapsedTimer time, int bytes) {
-      _time.add(time);
+      _time.add(&time);
       _bytes += bytes;
       _count++;
     }
     void reset() {
       _time.reset();
@@ -53,10 +54,13 @@
   };
 
  public:
   Data _standard;  // stats for non-OSR compilations
   Data _osr;       // stats for OSR compilations
+  Data _bailout;
+  Data _invalidated;
+  Data _made_not_entrant;
   uint _nmethods_size; //
   uint _nmethods_code_size;
 
   double total_time() { return _standard._time.seconds() + _osr._time.seconds(); }
 
